@InProceedings{KA-complexity,
  author =       "D. Kozen",
  title =        "On the Complexity of Reasoning in {Kleene} Algebra",
  pages =        "195--203",
  booktitle =    "12th Annual {IEEE} Symposium on Logic in Computer
                 Science ({LICS}'97)",
  ISBN =         "0-8186-7925-5",
  month =        jun,
  publisher =    "IEEE",
  address =      "Washington - Brussels - Tokyo",
  year =         "1997",
}

@Article{KAT,
  author =       "Dexter Kozen",
  title =        "{Kleene} Algebra with Tests",
  journal =      "ACM Transactions on Programming Languages and
                 Systems",
  volume =       "19",
  number =       "3",
  pages =        "427--443",
  month =        may,
  year =         "1997",
  CODEN =        "ATPSDT",
  ISSN =         "0164-0925",
  bibdate =      "Thu Sep 11 18:32:35 MDT 1997",
  URL =          "http://www.acm.org/pubs/citations/journals/toplas/1997-19-3/p427-kozen/",
  abstract =     "We introduce Kleene algebra with tests, an equational
                 system for manipulating programs. We give a purely
                 equational proof, using Kleene algebra with tests and
                 commutativity conditions, of the following classical
                 result: every {\bf while} program can be simulated by a
                 while program can be simulated by a {\bf while} program
                 with at most one {\bf while} loop. The proof
                 illustrates the use of Kleene algebra with tests and
                 commutativity conditions in program equivalence
                 proofs.",
  acknowledgement = ack-nhfb,
  keywords =     "design; languages; theory; verification",
  subject =      "{\bf D.2.2} Software, SOFTWARE ENGINEERING, Tools and
                 Techniques, Structured programming. {\bf D.2.4}
                 Software, SOFTWARE ENGINEERING, Program Verification,
                 Correctness proofs. {\bf D.3.3} Software, PROGRAMMING
                 LANGUAGES, Language Constructs and Features, Control
                 structures. {\bf F.3.1} Theory of Computation, LOGICS
                 AND MEANINGS OF PROGRAMS, Specifying and Verifying and
                 Reasoning about Programs, Assertions. {\bf F.3.1}
                 Theory of Computation, LOGICS AND MEANINGS OF PROGRAMS,
                 Specifying and Verifying and Reasoning about Programs,
                 Invariants. {\bf F.3.1} Theory of Computation, LOGICS
                 AND MEANINGS OF PROGRAMS, Specifying and Verifying and
                 Reasoning about Programs, Logics of programs. {\bf
                 F.3.1} Theory of Computation, LOGICS AND MEANINGS OF
                 PROGRAMS, Specifying and Verifying and Reasoning about
                 Programs, Mechanical verification. {\bf F.3.1} Theory
                 of Computation, LOGICS AND MEANINGS OF PROGRAMS,
                 Specifying and Verifying and Reasoning about Programs,
                 Pre- and post-conditions. {\bf F.3.1} Theory of
                 Computation, LOGICS AND MEANINGS OF PROGRAMS,
                 Specifying and Verifying and Reasoning about Programs,
                 Specification techniques. {\bf F.3.2} Theory of
                 Computation, LOGICS AND MEANINGS OF PROGRAMS, Semantics
                 of Programming Languages, Algebraic approaches to
                 semantics. {\bf F.3.3} Theory of Computation, LOGICS
                 AND MEANINGS OF PROGRAMS, Studies of Program
                 Constructs, Control primitives. {\bf I.1.1} Computing
                 Methodologies, ALGEBRAIC MANIPULATION, Expressions and
                 Their Representation, Simplification of expressions.
                 {\bf I.1.3} Computing Methodologies, ALGEBRAIC
                 MANIPULATION, Languages and Systems, Special-purpose
                 algebraic systems. {\bf I.2.2} Computing Methodologies,
                 ARTIFICIAL INTELLIGENCE, Automatic Programming, Program
                 modification. {\bf I.2.2} Computing Methodologies,
                 ARTIFICIAL INTELLIGENCE, Automatic Programming, Program
                 synthesis; program transformation; program
                 verification",
}

@InProceedings{KAT-Hoare,
  author =       "D. Kozen",
  title =        "On {Hoare} Logic and {Kleene} Algebra with Tests",
  pages =        "167--173",
  booktitle =    "14th Symposium on Logic in Computer Science
                 ({LICS}'99)",
  ISBN =         "0-7695-0158-3",
  month =        jul,
  publisher =    "IEEE",
  address =      "Washington - Brussels - Tokyo",
  year =         "1999",
}

@article{KAT-Hoare-simpler,
 author = {Ernie Cohen and Dexter Kozen},
 title = {A note on the complexity of propositional {Hoare} logic},
 journal = {ACM Trans. Comput. Logic},
 volume = {1},
 number = {1},
 year = {2000},
 issn = {1529-3785},
 pages = {171--174},
 doi = {http://doi.acm.org/10.1145/343369.343404},
 publisher = {ACM Press},
 address = {New York, NY, USA},
 }

@Article{KAT-commutativity,
  author =       "D. Kozen",
  title =        "{Kleene} Algebra with Tests and Commutativity
                 Conditions",
  journal =      "Lecture Notes in Computer Science",
  volume =       "1055",
  pages =        "14--??",
  year =         "1996",
  CODEN =        "LNCSD9",
  ISSN =         "0302-9743",
  bibdate =      "Sat May 11 13:45:32 MDT 1996",
  acknowledgement = ack-nhfb,
}


@InProceedings{KAT-complete-decidable,
  author =       "Kozen and Smith",
  title =        "{Kleene} Algebra with Tests: Completeness and
                 Decidability",
  booktitle =    "CSL: 10th Workshop on Computer Science Logic",
  publisher =    "LNCS, Springer-Verlag",
  year =         "1996",
}


@Article{KA-regevents-complete,
  refkey =       "C1459",
  title =        "A Completeness Theorem for {Kleene} Algebras and the
                 Algebra of Regular Events",
  author =       "Dexter Kozen",
  pages =        "366--390",
  journal =      "Information and Computation",
  month =        "1~" # may,
  year =         "1994",
  volume =       "110",
  number =       "2",
  preliminary =  "LICS::Kozen1991:214",
  abstract =     "We give a finitary axiomatization of the algebra of
                 regular events involving only equations and equational
                 implications. Unlike Salomaa's axiomatizations, the
                 axiomatization given here is sound for all
                 interpretations over Kleene algebras.",
  xxx-references = "Immerman86, LICS::Kozen91, Leivant90, FOCS::Safra88,
                 JACM::Salomaa66, LICS::Walukiewicz93",
  references =   "\cite{IC::Immerman1986} \cite{LICS::Kozen1991}
                 \cite{IC::Leivant1990} \cite{FOCS::Safra1988}
                 \cite{JACM::Salomaa1966} \cite{LICS::Walukiewicz1993}",
}

@Misc{KA-hypo,
  title =        "Hypotheses in {Kleene} Algebra",
  author =       "Ernie Cohen",
  year =         "1993",
  month =        feb # "~03",
  abstract =     "Kleene algebra (an Horn axiomatization of Kleene's
                 algebra of regular events) has proved to be an
                 effective tool for reasoning about programs. Within the
                 algebra, we can reason succinctly about both ordinary
                 safety properties and important program transformations
                 such as loop unwinding, change of data representation,
                 and refinement of atomicity. One of the nice properties
                 of Kleene algebra is that its equational theory has a
                 simple decision procedure. However, to use it for
                 programming applications, we need to reason in the
                 presence of hypotheses stating the equality of certain
                 programs; such hypotheses can, in general, render the
                 theory undecidable. In this note, we show that for
                 certain important cases, checking an equation under
                 hypotheses can be reduced to checking a related
                 equation without hypotheses. 1 Introduction A Kleene
                 algebra (KA) is an algebraic structure (K; +; ; ; ; 0;
                 1) satisfying the following axioms (we use infix
                 notation for + and ;, and postfix notation for ,
                 an...",
  citeseer-references = "oai:CiteSeerPSU:111064",
  annote =       "The Pennsylvania State University CiteSeer Archives",
  language =     "en",
  oai =          "oai:CiteSeerPSU:1688",
  rights =       "unrestricted",
  subject =      "Ernie Cohen Hypotheses in {Kleene} Algebra",
  URL =          "http://citeseer.ist.psu.edu/1688.html;
                 ftp://thumper.bellcore.com/pub/ernie/research/kozen.ps.gz",
}

@Misc{KAT-complexity,
  title =        "The Complexity of {Kleene} Algebra with Tests",
  author =       "Dexter Kozen and Ernie Cohen and Frederick Smith",
  year =         "1996",
  month =        oct # "~11",
  abstract =     "Kleene algebras with tests provide a natural framework
                 for equational specification and verification. Kleene
                 algebras with tests and related systems have been used
                 successfully in basic safety analysis, source-to-source
                 program transformation, and concurrency control. The
                 equational theory of Kleene algebras with tests has
                 been shown to be decidable in at most exponential time
                 by an efficient reduction to Propositional Dynamic
                 Logic. In this paper we prove that the theory is
                 PSPACE-complete. 1 Introduction Kleene algebra with
                 tests (KAT) [15] is an algebraic system intermediate to
                 Kleene algebra (KA) and Propositional Dynamic Logic
                 (PDL) in expressive power. One can use KAT for a range
                 of common verification tasks without resorting to the
                 full power of PDL. KAT and related systems have been
                 applied successfully to real problems in basic safety
                 analysis, source-to-source 1 Bell Communications
                 Research Inc., 445 South St., Morristown, NJ 07960, USA
                 2 Computer Science Department, Cor...",
  citeseer-references = "oai:CiteSeerPSU:62200; oai:CiteSeerPSU:188632",
  annote =       "The Pennsylvania State University CiteSeer Archives",
  language =     "en",
  oai =          "oai:CiteSeerPSU:85616",
  rights =       "unrestricted",
  subject =      "Dexter Kozen,Ernie Cohen,Frederick Smith The
                 Complexity of Kleene Algebra with Tests",
  URL =          "http://citeseer.ist.psu.edu/85616.html;
                 http://www.cs.cornell.edu/kozen/papers/ckat.ps",
}

@techreport{KA-lect04,
  author = 	 {Dexter Kozen},
  title = 	 {Introduction to {Kleene} Algebra},
  howpublished = {\url!http://www.cs.cornell.edu/Courses/cs786/2004sp/Lectures/lectures.htm!},
  year = 	 {2004},
  note = 	 {\url!http://www.cs.cornell.edu/Courses/cs786/2004sp/Lectures/lectures.htm!},
  institution =  {Cornell University},
 address = {Ithaca, NY, USA},
  type = 	 {Course notes},
}

@techreport{KA-lect02,
  author = 	 {Dexter Kozen},
  title = 	 {Introduction to {Kleene} Algebra},
  howpublished = {\url!http://www.cs.cornell.edu/Courses/cs786/2002sp/Lectures/lectures.htm!},
  year = 	 {2002},
  note = 	 {\url!http://www.cs.cornell.edu/Courses/cs786/2002sp/Lectures/lectures.htm!},
  institution =  {Cornell University},
 address = {Ithaca, NY, USA},
  type = 	 {Course notes},
}

@techreport{lectAK,
  editor = 	 {Jules Desharnais},
  author = 	 {H. Bherer and C. Bolduc and V. Mathieu},
  title = 	 {Alg\`{e}bres de {Kleene}},
  howpublished = {\url!www.ift.ulaval.ca/~desharnais/ Recherche/AutresPubs/LectureDirigee2003.pdf!},
  year = 	 {2003},
  note = 	 {Useful index.},
  type = 	 {Rapport de lecture dirig\'{e}e},
  institution =  {Universit\'{e} Laval},
}

@techreport{AGS,
 author = {Dexter Kozen},
 title = {Automata on Guarded Strings and Applications},
 year = {2001},
 source = {http://www.ncstrl.org:8900/ncstrl/servlet/search?formname=detail\&id=oai%3Ancstrlh%3Acornellcs%3ACORNELLCS%3ATR2001-1833},
 publisher = {Cornell University},
 address = {Ithaca, NY, USA},
  institution =  {Cornell University},
 }


@techreport{REL-Horn-complexity,
 author = {Chris Hardin and Dexter Kozen},
 title = {On the Complexity of the Horn Theory of REL},
 year = {2003},
  month = 	 {may},
 publisher = {Cornell University},
 address = {Ithaca, NY, USA},
  institution =  {Cornell University},
  note = 	 {\url!http://www.math.cornell.edu/~hardin/papers/hornrel.ps!},
 }

@techreport{KAT-elimination,
 author = {Chris Hardin and Dexter Kozen},
 title = {On the Elimination of Hypotheses in {Kleene} Algebra with Tests},
 year = {2002},
  month = 	 {oct},
 publisher = {Cornell University},
 address = {Ithaca, NY, USA},
  institution =  {Cornell University},
  note = 	 {\url!http://www.math.cornell.edu/~hardin/papers/hornrel.ps!},
 }

@Unpublished{Cohen-hypo,
  author = 	 {Ernie Cohen},
  title = 	 {Hypotheses in {Kleene} Algebra},
  year = 	 {1994},
}

@InProceedings{Cohen-annihilating-annih,
  author = 	 {Ernie Cohen},
  title = 	 {Annihilating the annihilation axioms},
  year = 	 {2003},
  note = 	 {\url!http://www.informatik.uni-kiel.de/~relmics7/submitted/Cohen/annihilatorsAbstract.ps.gz!},
  booktitle = 	 {RelMiCS 7},
}

@InProceedings{KA-proof-theory,
  author = 	 {Chris Hardin},
  title = 	 {Proof Theory for {Kleene} Algebra},
  year = 	 {2005},
  note = 	 {To be presented at LICS 2005. \url!http://www.math.cornell.edu/~hardin/papers/prooftheory.ps!},
  booktitle = 	 {LICS 2005 (Logic in Computer Science)},
}

@InProceedings{KA-modular-elimination,
  author = 	 {Chris Hardin},
  title = 	 {Modularizing the Elimination of $r=0$ in {Kleene} Algebra},
  year = 	 {2005},
  note = 	 {Submitted to Logical Methods in Computer Science. \url!http://www.math.cornell.edu/~hardin/papers/rzeroelim.ps!},
  month = 	 {apr},
  booktitle = 	 {Submitted to Logical Methods in Computer Science},
}

